## mingw-w64-tfel-5.1.0-2.src.tar.zst

=== docs/CMakeLists.txt ===
if(GENERATE_DOXYGEN)
  add_subdirectory(doxygen)
endif(GENERATE_DOXYGEN)

if(GENERATE_REFERENCE_DOC)
  add_subdirectory(tfel)
  add_subdirectory(release-notes-2.0)
  add_subdirectory(release-notes-2.0.3)
  add_subdirectory(release-notes-2.0.4)
  add_subdirectory(release-notes-3.0)
  add_subdirectory(tutorial)
  add_subdirectory(presentations)
endif(GENERATE_REFERENCE_DOC)

if(GENERATE_WEBSITE)
  add_subdirectory(web)
endif(GENERATE_WEBSITE)

add_subdirectory(gallery)
add_subdirectory(mfront)
add_subdirectory(mtest)
add_subdirectory(ptest)

=== env/CMakeLists.txt ===
if(UNIX)
  if(enable-python-bindings)
    configure_file(env-python.sh.in env.sh @ONLY)
    configure_file(env-python.fish.in env.fish @ONLY)
  else(enable-python-bindings) 
   configure_file(env.sh.in env.sh @ONLY)
   configure_file(env.fish.in env.fish @ONLY)
  endif(enable-python-bindings)
  if(TFEL_SUFFIX)
    install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/env.sh
            ${CMAKE_CURRENT_BINARY_DIR}/env.fish
            DESTINATION share/tfel-${TFEL_SUFFIX}/env
            COMPONENT core)
  else(TFEL_SUFFIX)
    install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/env.sh
            ${CMAKE_CURRENT_BINARY_DIR}/env.fish
            DESTINATION share/tfel/env
            COMPONENT core)
  endif(TFEL_SUFFIX)
endif(UNIX)

if(WIN32)
  if(enable-python-bindings)
    cmake_path(NATIVE_PATH TFEL_PYTHON_SITE_PACKAGES_DIR NATIVE_TFEL_PYTHON_SITE_PACKAGES_DIR)
    configure_file(env-python.ps1.in env.ps1 @ONLY)
    configure_file(env-python.bat.in env.bat @ONLY)
  else(enable-python-bindings) 
   configure_file(env.ps1.in env.ps1 @ONLY)
   configure_file(env.bat.in env.bat @ONLY)
  endif(enable-python-bindings)
  if(TFEL_SUFFIX)
    install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/env.ps1
            ${CMAKE_CURRENT_BINARY_DIR}/env.bat
            DESTINATION share/tfel-${TFEL_SUFFIX}/env
            COMPONENT core)
  else(TFEL_SUFFIX)
    install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/env.ps1
            ${CMAKE_CURRENT_BINARY_DIR}/env.bat
            DESTINATION share/tfel/env
            COMPONENT core)
  endif(TFEL_SUFFIX)
endif(WIN32)

=== include/CMakeLists.txt ===

install_header(TFEL Macros.hxx)
install_header(TFEL ContractViolation.hxx)
install_header(TFEL Raise.hxx)
install_header(TFEL Raise.ixx)
install_header(TFEL PhysicalConstants.hxx)

install_header(TFEL/Config/Internals TFELTypesInternals.hxx)
install_header(TFEL/Config TFEL_MATH_Config.hxx)
install_header(TFEL/Config TFELTypes.hxx)
install_header(TFEL/Config TFELConfig.hxx)
install_header(TFEL/Config GetInstallPath.hxx)
install_header(TFEL/Config GetTFELVersion.h)

install_header(TFEL/Glossary/Forward Glossary.hxx)
install_header(TFEL/Glossary Glossary.hxx)
install_header(TFEL/Glossary GlossaryEntry.hxx)

install_header(TFEL/UnicodeSupport UnicodeSupport.hxx)

install_header(TFEL/Metaprogramming/Forward TypeList.hxx)
install_header(TFEL/Metaprogramming Concepts.hxx)
install_header(TFEL/Metaprogramming Implements.hxx)
install_header(TFEL/Metaprogramming TypeList.hxx)
install_header(TFEL/Metaprogramming TypeList.ixx)
install_header(TFEL/Metaprogramming GenerateTypeList.hxx)
install_header(TFEL/Metaprogramming InvalidType.hxx)
install_header(TFEL/Metaprogramming HasIterator.hxx)
install_header(TFEL/Metaprogramming HasConstIterator.hxx)
install_header(TFEL/Metaprogramming HasRandomAccessConstIterator.hxx)
install_header(TFEL/Metaprogramming EmptyClass.hxx)
install_header(TFEL/Metaprogramming HasRandomAccessIterator.hxx)
install_header(TFEL/Metaprogramming MakeIntegerRange.hxx)

install_header(TFEL/TypeTraits/Promote Promote.ixx)
install_header(TFEL/TypeTraits BaseType.hxx)
install_header(TFEL/TypeTraits AbsType.hxx)
install_header(TFEL/TypeTraits RealPartType.hxx)
install_header(TFEL/TypeTraits IsFundamentalNumericType.hxx)
install_header(TFEL/TypeTraits IsReal.hxx)
install_header(TFEL/TypeTraits IsScalar.hxx)
install_header(TFEL/TypeTraits IsComplex.hxx)
install_header(TFEL/TypeTraits Promote.hxx)
install_header(TFEL/TypeTraits IsAssignableTo.hxx)
install_header(TFEL/TypeTraits IsUnaryOperator.hxx)
install_header(TFEL/TypeTraits IsInvalid.hxx)
install_header(TFEL/TypeTraits IsRandomAccessIterator.hxx)

install_header(TFEL/System RecursiveFind.hxx)
install_header(TFEL/System ExternalMaterialKnowledgeDescription.hxx)
install_header(TFEL/System ExternalMaterialPropertyDescription.hxx)
install_header(TFEL/System ExternalBehaviourDescription.hxx)
install_header(TFEL/System ExternalFunctionsPrototypes.hxx)
install_header(TFEL/System ExternalLibraryManager.hxx)
install_header(TFEL/System ProcessManager.h)
install_header(TFEL/System ProcessManager.hxx)
install_header(TFEL/System SignalHandler.ixx)
install_header(TFEL/System SystemError.hxx)
install_header(TFEL/System System.hxx)
install_header(TFEL/System SignalHandler.hxx)
install_header(TFEL/System SignalManager.hxx)
install_header(TFEL/System SystemError.ixx)
install_header(TFEL/System ChildProcess.hxx)
install_header(TFEL/System BinaryRead.hxx)
install_header(TFEL/System BinaryWrite.hxx)
install_header(TFEL/System STLContainerBinaryRead.hxx)
install_header(TFEL/System STLContainerBinaryWrite.hxx)
install_header(TFEL/System stream_traits.hxx)
install_header(TFEL/System basic_rstream.hxx)
install_header(TFEL/System basic_rstream.ixx)
install_header(TFEL/System basic_wstream.hxx)
install_header(TFEL/System basic_wstream.ixx)
install_header(TFEL/System rstreamView.hxx)
install_header(TFEL/System rstreamView.ixx)
install_header(TFEL/System wstreamView.hxx)
install_header(TFEL/System wstreamView.ixx)
install_header(TFEL/System rfstream.hxx)
install_header(TFEL/System wfstream.hxx)
install_header(TFEL/System getFunction.h)
install_header(TFEL/System ThreadPool.hxx)
install_header(TFEL/System ThreadPool.ixx)
install_header(TFEL/System ThreadedTaskResult.hxx)
install_header(TFEL/System ThreadedTaskResult.ixx)
install_header(TFEL/System LibraryInformation.hxx)

install_header(TFEL/Utilities StringAlgorithms.hxx)
install_header(TFEL/Utilities Argument.hxx)
install_header(TFEL/Utilities ArgumentParser.hxx)
install_header(TFEL/Utilities ArgumentParserBase.hxx)
install_header(TFEL/Utilities ArgumentParserBase.ixx)
install_header(TFEL/Utilities CxxKeywords.hxx)
install_header(TFEL/Utilities CxxTokenizerOptions.hxx)
install_header(TFEL/Utilities CxxTokenizer.hxx)
install_header(TFEL/Utilities CxxTokenizer.ixx)
install_header(TFEL/Utilities Token.hxx)
install_header(TFEL/Utilities Data.hxx)
install_header(TFEL/Utilities Data.ixx)
install_header(TFEL/Utilities TerminalColors.hxx)
install_header(TFEL/Utilities GenTypeCastError.hxx)
install_header(TFEL/Utilities GenTypeBase.hxx)
install_header(TFEL/Utilities GenTypeBase.ixx)
install_header(TFEL/Utilities GenTypeSpecialisation.ixx)
install_header(TFEL/Utilities TextData.hxx)
install_header(TFEL/Utilities FCString.hxx)
install_header(TFEL/Utilities FCString.ixx)

install_header(TFEL/Exception TFELException.hxx)

install_header(TFEL/FSAlgorithm loop.hxx)
install_header(TFEL/FSAlgorithm swap_ranges.hxx)
install_header(TFEL/FSAlgorithm copy.hxx)
install_header(TFEL/FSAlgorithm generate.hxx)
install_header(TFEL/FSAlgorithm inner_product.hxx)
install_header(TFEL/FSAlgorithm transform.hxx)
install_header(TFEL/FSAlgorithm iota.hxx)
install_header(TFEL/FSAlgorithm min_element.hxx)
install_header(TFEL/FSAlgorithm max_element.hxx)
install_header(TFEL/FSAlgorithm FSAlgorithm.hxx)
install_header(TFEL/FSAlgorithm accumulate.hxx)
install_header(TFEL/FSAlgorithm fill.hxx)
install_header(TFEL/FSAlgorithm for_each.hxx)
install_header(TFEL/FSAlgorithm equal.hxx)

install_header(TFEL/Math/Forward vector.hxx)
install_header(TFEL/Math/Forward qt.hxx)
install_header(TFEL/Math/Forward Complex.hxx)
install_header(TFEL/Math/Forward fsarray.hxx)
install_header(TFEL/Math/Forward runtime_array.hxx)
install_header(TFEL/Math/Forward tvector.hxx)
install_header(TFEL/Math/Forward tmatrix.hxx)
install_header(TFEL/Math/Forward matrix.hxx)
install_header(TFEL/Math/Forward tensor.hxx)
install_header(TFEL/Math/Forward stensor.hxx)
install_header(TFEL/Math/Forward t2tot2.hxx)
install_header(TFEL/Math/Forward t2tost2.hxx)
install_header(TFEL/Math/Forward st2tot2.hxx)
install_header(TFEL/Math/Forward st2tost2.hxx)
install_header(TFEL/Math/Forward Expr.hxx)

install_header(TFEL/Math types.hxx)
install_header(TFEL/Math types.ixx)
install_header(TFEL/Math/Bindings atlas.hxx)
install_header(TFEL/Math fsarray.hxx)
install_header(TFEL/Math runtime_array.hxx)
install_header(TFEL/Math power.hxx)
install_header(TFEL/Math power.ixx)
install_header(TFEL/Math Discretization1D.hxx)
install_header(TFEL/Math Discretization1D.ixx)
install_header(TFEL/Math/Array ArrayConcept.hxx)
install_header(TFEL/Math/Array fsarrayIO.hxx)
install_header(TFEL/Math/Array runtime_arrayIO.hxx)
install_header(TFEL/Math/Array StandardTemplateLibraryCompatibilityLayers.hxx)
install_header(TFEL/Math/Array StandardTemplateLibraryCompatibilityLayers.ixx)
install_header(TFEL/Math/Array ArrayCommonMethods.hxx)
install_header(TFEL/Math/Array ArrayCommonMethods.ixx)
install_header(TFEL/Math/Array ArrayPolicies.hxx)
install_header(TFEL/Math/Array ArrayPolicies.ixx)
install_header(TFEL/Math/Array ConstFixedSizeArrayBase.hxx)
install_header(TFEL/Math/Array ConstFixedSizeArrayBase.ixx)
install_header(TFEL/Math/Array ConstRuntimeArrayBase.hxx)
install_header(TFEL/Math/Array ConstRuntimeArrayBase.ixx)
install_header(TFEL/Math/Array View.hxx)
install_header(TFEL/Math/Array ViewsArray.hxx)
install_header(TFEL/Math/Array ViewsArrayIO.hxx)
install_header(TFEL/Math/Array CoalescedView.hxx)
install_header(TFEL/Math/Array FixedSizeArrayPolicies.hxx)
install_header(TFEL/Math/Array FixedSizeIndexingPolicies.hxx)
install_header(TFEL/Math/Array GenericFixedSizeArray.hxx)
install_header(TFEL/Math/Array GenericFixedSizeArray.ixx)
install_header(TFEL/Math/Array GenericRuntimeArray.hxx)
install_header(TFEL/Math/Array GenericRuntimeArray.ixx)
install_header(TFEL/Math/Array IndexingPolicies.hxx)
install_header(TFEL/Math/Array IndexingPolicies.ixx)
install_header(TFEL/Math/Array IterateOverMultipleIndices.hxx)
install_header(TFEL/Math/Array MultipleIndicesFunctors.hxx)
install_header(TFEL/Math/Array MutableFixedSizeArrayBase.hxx)
install_header(TFEL/Math/Array MutableFixedSizeArrayBase.ixx)
install_header(TFEL/Math/Array MutableRuntimeArrayBase.hxx)
install_header(TFEL/Math/Array MutableRuntimeArrayBase.ixx)
install_header(TFEL/Math/Array RuntimeArrayPolicies.hxx)
install_header(TFEL/Math/Array RuntimeIndexingPolicies.hxx)
install_header(TFEL/Math/Array FixedSizeArrayDerivative.hxx)
install_header(TFEL/Math/Parser BinaryFunction.hxx)
install_header(TFEL/Math/Parser EvaluatorBase.hxx)
install_header(TFEL/Math/Parser Negation.hxx)
install_header(TFEL/Math/Parser BinaryFunction.ixx)
install_header(TFEL/Math/Parser Expr.hxx)
install_header(TFEL/Math/Parser Number.hxx)
install_header(TFEL/Math/Parser BinaryOperator.hxx)
install_header(TFEL/Math/Parser BinaryOperator.ixx)
install_header(TFEL/Math/Parser Function.hxx)
install_header(TFEL/Math/Parser Function.ixx)
install_header(TFEL/Math/Parser PowerFunction.hxx)
install_header(TFEL/Math/Parser PowerFunction.ixx)
install_header(TFEL/Math/Parser Variable.hxx)
install_header(TFEL/Math/Parser ExternalCFunction.hxx)
install_header(TFEL/Math/Parser ExternalCastemFunction.hxx)
install_header(TFEL/Math/Parser ExternalCyranoFunction.hxx)
install_header(TFEL/Math/Parser ExternalFunction.hxx)
install_header(TFEL/Math/Parser ConstantExternalFunction.hxx)
install_header(TFEL/Math/Parser ExternalFunctionManager.hxx)
install_header(TFEL/Math/Parser ExternalFunctionExpr.hxx)
install_header(TFEL/Math/Parser ExternalFunctionExpr2.hxx)
install_header(TFEL/Math/Parser DifferentiatedFunctionExpr.hxx)
install_header(TFEL/Math/Parser KrigedFunction.hxx)
install_header(TFEL/Math/Parser KrigedFunction.ixx)
install_header(TFEL/Math/Parser EvaluatorTExpr.hxx)
install_header(TFEL/Math/Parser EvaluatorTExpr.ixx)
install_header(TFEL/Math/Parser IntegerEvaluatorTExpr.hxx)
install_header(TFEL/Math/Parser EvaluatorProxy.hxx)
install_header(TFEL/Math/Parser EvaluatorProxy.ixx)
install_header(TFEL/Math/Parser LogicalExpr.hxx)
install_header(TFEL/Math/Parser LogicalExpr.ixx)
install_header(TFEL/Math/Parser ConditionalExpr.hxx)
install_header(TFEL/Math/Parser EvaluatorFunction.hxx)
install_header(TFEL/Math/Parser EvaluatorFunction.ixx)
install_header(TFEL/Math/Parser LevenbergMarquardtEvaluatorWrapper.hxx)
install_header(TFEL/Math/Parser LevenbergMarquardtExternalFunctionWrapper.hxx)
install_header(TFEL/Math Evaluator.hxx)
install_header(TFEL/Math IntegerEvaluator.hxx)
install_header(TFEL/Math Kriging.hxx)
install_header(TFEL/Math Kriging1D.hxx)
install_header(TFEL/Math Kriging2D.hxx)
install_header(TFEL/Math Kriging3D.hxx)
install_header(TFEL/Math FactorizedKriging.hxx)
install_header(TFEL/Math FactorizedKriging1D1D.hxx)
install_header(TFEL/Math FactorizedKriging1D2D.hxx)
install_header(TFEL/Math FactorizedKriging1D3D.hxx)
install_header(TFEL/Math LinearInterpolation.hxx)
install_header(TFEL/Math LinearInterpolation.ixx)
install_header(TFEL/Math CubicSpline.hxx)
install_header(TFEL/Math CubicSpline.ixx)
install_header(TFEL/Math/Kriging Kriging.ixx)
install_header(TFEL/Math/Kriging KrigingUtilities.hxx)
install_header(TFEL/Math/Kriging KrigingPieceWiseLinearModel1D.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModel1D.hxx)
install_header(TFEL/Math/Kriging KrigingErrors.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultNuggetModel.hxx)
install_header(TFEL/Math/Kriging FactorizedKriging.ixx)
install_header(TFEL/Math/Kriging KrigingVariable.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModel3D.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModels.hxx)
install_header(TFEL/Math/Kriging KrigingDefaultModel2D.hxx)
install_header(TFEL/Math LUSolve.hxx)
install_header(TFEL/Math/LU LUException.hxx)
install_header(TFEL/Math/LU Permutation.hxx)
install_header(TFEL/Math/LU Permutation.ixx)
install_header(TFEL/Math/LU TinyPermutation.hxx)
install_header(TFEL/Math/LU TinyPermutation.ixx)
install_header(TFEL/Math/LU TinyMatrixSolve.ixx)
install_header(TFEL/Math/LU LUDecomp.hxx)

=== docs/ptest/CMakeLists.txt ===
if(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

  configure_file(ptest.tex.in
    ptest.tex @ONLY)
  
  ADD_CUSTOM_COMMAND(
    OUTPUT    ptest.pdf
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/ptest.tex.in
    COMMAND   TEXMFHOME=${abs_top_srcdir}/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS       ptest.tex
    COMMAND   TEXMFHOME=${abs_top_srcdir}/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS       ptest.tex
# COMMAND   BSTINPUTS=${abs_top_srcdir}/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
# ARGS      -terse ptest
# COMMAND   ${MAKEINDEX_COMPILER}
# ARGS      -s ${CMAKE_CURRENT_SOURCE_DIR}/style.ist mkeys.idx
    COMMAND   TEXMFHOME=${abs_top_srcdir}/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS       ptest.tex
    COMMAND   TEXMFHOME=${abs_top_srcdir}/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS       ptest.tex
    COMMENT   "ptest.pdf")
  
  add_custom_target(ptest-doc-pdf ALL DEPENDS ptest.pdf)
  add_dependencies(doc-pdf
    ptest-doc-pdf)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/mtest-${TFEL_SUFFIX}/ptest
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/ptest
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/mtest/ptest
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/tfel/web/documents/ptest
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endif(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

=== mfm/src/CMakeLists.txt ===
add_executable(mfm mfm.cxx)
target_link_libraries(mfm
  tfel::TFELUtilities
  tfel::TFELMFrontDatabase)
set_property(TARGET mfm PROPERTY POSITION_INDEPENDENT_CODE TRUE)
if(TFEL_APPEND_SUFFIX)
  set_target_properties(mfm
    PROPERTIES OUTPUT_NAME "mfm-${TFEL_SUFFIX}")
endif(TFEL_APPEND_SUFFIX)
install(TARGETS mfm DESTINATION bin COMPONENT mfm)

=== mfm/tests/CMakeLists.txt ===
macro(mfm_test args mfront_library file)
  if(NOT MFM_TEST_ID)
    set(MFM_TEST_ID 0)
  endif(NOT MFM_TEST_ID)
  set(test "mfm-test-${MFM_TEST_ID}")
  add_test(NAME ${test}
      COMMAND ${CMAKE_COMMAND}
      -D TEST_PROGRAM=$<TARGET_FILE:mfm>
      -D TEST_ARGS=${args}
      -D LIBRARY=${mfront_library}
      -D TEST_OUTPUT=mfm-result-${MFM_TEST_ID}.txt
      -D REFERENCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/references/${file}
      -P ${CMAKE_CURRENT_SOURCE_DIR}/mfm.cmake )
  set_property(TEST ${test} PROPERTY DEPENDS "mfm")
  # The previous definition with generators, which does not work !!
  #
  #   add_test(mfm-test-${MFM_TEST_ID}
  #     ${CMAKE_COMMAND}
  #     -D CONFIG=$<CONFIG>
  #     -D TEST_PROGRAM=${mfm}
  # # ${PROJECT_BINARY_DIR}/mfm/src/mfm${CMAKE_EXECUTABLE_SUFFIX}
  #     -D TEST_ARGS=${args}
  #     -D MFRONT_FILE=${PROJECT_SOURCE_DIR}/mfront/tests/behaviours/${mfront_file}
  #     -D TEST_OUTPUT=mfm-result-${MFM_TEST_ID}.txt
  #     -D REFERENCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/references/${file}
  #     -P ${CMAKE_CURRENT_SOURCE_DIR}/mfm.cmake )
  MATH(EXPR MFM_TEST_ID "${MFM_TEST_ID}+1")
endmacro(mfm_test)

if(HAVE_CASTEM)
mfm_test("--filter-by-name=.+t91.+" $<TARGET_FILE:MFrontCastemBehaviours>
  "mfm-t91.ref")
endif(HAVE_CASTEM)
# mfm_test("--state-variables" "Norton.mfront"
#   "mfm-norton-material-properites.ref")

=== mfront-query/tests/CMakeLists.txt ===
macro(mfront_query_test args mfront_file file)
  if(NOT MFRONT_QUERY_TEST_ID)
    set(MFRONT_QUERY_TEST_ID 0)
  endif(NOT MFRONT_QUERY_TEST_ID)
  set(test "mfront-query-test-${MFRONT_QUERY_TEST_ID}")
  add_test(NAME ${test}
      COMMAND ${CMAKE_COMMAND}
      -D TEST_PROGRAM=$<TARGET_FILE:mfront-query>
      -D TEST_ARGS=${args}
      -D MFRONT_FILE=${PROJECT_SOURCE_DIR}/mfront/tests/behaviours/${mfront_file}
      -D TEST_OUTPUT=mfront-query-result-${MFRONT_QUERY_TEST_ID}.txt
      -D REFERENCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/references/${file}
      -P ${CMAKE_CURRENT_SOURCE_DIR}/mfront-query.cmake )
  set_property(TEST ${test} PROPERTY DEPENDS "mfront-query")
  # The previous definition with generators, which does not work !!
  #
  #   add_test(mfront-query-test-${MFRONT_QUERY_TEST_ID}
  #     ${CMAKE_COMMAND}
  #     -D CONFIG=$<CONFIG>
  #     -D TEST_PROGRAM=${mfront_query}
  # # ${PROJECT_BINARY_DIR}/mfront-query/src/mfront-query${CMAKE_EXECUTABLE_SUFFIX}
  #     -D TEST_ARGS=${args}
  #     -D MFRONT_FILE=${PROJECT_SOURCE_DIR}/mfront/tests/behaviours/${mfront_file}
  #     -D TEST_OUTPUT=mfront-query-result-${MFRONT_QUERY_TEST_ID}.txt
  #     -D REFERENCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/references/${file}
  #     -P ${CMAKE_CURRENT_SOURCE_DIR}/mfront-query.cmake )
  MATH(EXPR MFRONT_QUERY_TEST_ID "${MFRONT_QUERY_TEST_ID}+1")
endmacro(mfront_query_test)

mfront_query_test("--material-properties"
  "Norton.mfront"
  "mfront-query-norton-material-properites.ref")
mfront_query_test("--slip-systems-by-index"
  "FiniteStrainSingleCrystal/FiniteStrainSingleCrystal.mfront"
  "mfront-query-finitestrainsinglecrystal.ref")
# mfront_query_test("--state-variables" "Norton.mfront"
#   "mfront-query-norton-material-properites.ref")

=== mfront/include/CMakeLists.txt ===
install_mfront_header(MFront MFront.hxx)
install_mfront_header(MFront GlobalDomainSpecificLanguageOptionsManager.hxx)
install_mfront_header(MFront SearchPathsHandler.hxx)
install_mfront_header(MFront MaterialKnowledgeType.hxx)
install_mfront_header(MFront MFrontBase.hxx)
install_mfront_header(MFront MaterialKnowledgeAttribute.hxx)
install_mfront_header(MFront MaterialKnowledgeDescription.hxx)
install_mfront_header(MFront MaterialKnowledgeDescription.ixx)
install_mfront_header(MFront PathSpecifier.hxx)
install_mfront_header(MFront MFrontUtilities.hxx)
install_mfront_header(MFront MFrontUtilities.ixx)
install_mfront_header(MFront GeneratorOptions.hxx)
install_mfront_header(MFront CMakeGenerator.hxx)
install_mfront_header(MFront MakefileGenerator.hxx)
install_mfront_header(MFront CodeBlock.hxx)
install_mfront_header(MFront CodeBlock.ixx)
install_mfront_header(MFront MFrontConfig.hxx)
install_mfront_header(MFront MFrontWarningMode.hxx)
install_mfront_header(MFront MFrontDebugMode.hxx)
install_mfront_header(MFront PedanticMode.hxx)
install_mfront_header(MFront MFrontLogStream.hxx)
install_mfront_header(MFront GenericData.hxx)
install_mfront_header(MFront FileDescription.hxx)
install_mfront_header(MFront TargetsDescription.hxx)
install_mfront_header(MFront CompiledTargetDescriptionBase.hxx)
install_mfront_header(MFront DataInterpolationUtilities.hxx)
install_mfront_header(MFront OverridableImplementation.hxx)
install_mfront_header(MFront OverridableImplementation.ixx)
install_mfront_header(MFront LibraryDescription.hxx)
install_mfront_header(MFront ExecutableDescription.hxx)
install_mfront_header(MFront SpecificTargetDescription.hxx)
install_mfront_header(MFront MFrontLock.hxx)
install_mfront_header(MFront InitDSLs.hxx)
install_mfront_header(MFront InitInterfaces.hxx)
install_mfront_header(MFront MFrontHeader.hxx)
install_mfront_header(MFront BehaviourDSLDescription.hxx)
install_mfront_header(MFront IntegrationScheme.hxx)
install_mfront_header(MFront AbstractDSL.hxx)
install_mfront_header(MFront AbstractBehaviourDSL.hxx)
install_mfront_header(MFront BehaviourDSLCommon.hxx)
install_mfront_header(MFront BehaviourDSLBase.hxx)
install_mfront_header(MFront BehaviourDSLBase.ixx)
install_mfront_header(MFront ImplicitDSLBase.hxx)
install_mfront_header(MFront NonLinearSystemSolver.hxx)
install_mfront_header(MFront NonLinearSystemSolverFactory.hxx)
install_mfront_header(MFront ImplicitDSL.hxx)
install_mfront_header(MFront ImplicitDSLII.hxx)
install_mfront_header(MFront ImplicitFiniteStrainDSL.hxx)
install_mfront_header(MFront InstallPath.hxx)
install_mfront_header(MFront DefaultGenericBehaviourDSL.hxx)
install_mfront_header(MFront DefaultModelDSL.hxx)
install_mfront_header(MFront ImplicitGenericBehaviourDSL.hxx)
install_mfront_header(MFront ImplicitModelDSL.hxx)
install_mfront_header(MFront ImplicitCZMDSL.hxx)
install_mfront_header(MFront DSLFactory.hxx)
install_mfront_header(MFront DSLProxy.hxx)
install_mfront_header(MFront DSLProxy.ixx)
install_mfront_header(MFront AbstractMaterialPropertyInterface.hxx)
install_mfront_header(MFront AbstractBehaviourInterface.hxx)
install_mfront_header(MFront BehaviourInterfaceProxy.hxx)
install_mfront_header(MFront BehaviourInterfaceProxy.ixx)
install_mfront_header(MFront BehaviourInterfaceFactory.hxx)
install_mfront_header(MFront AbstractModelInterface.hxx)
install_mfront_header(MFront ModelInterfaceProxy.hxx)
install_mfront_header(MFront ModelInterfaceProxy.ixx)
install_mfront_header(MFront ModelInterfaceFactory.hxx)
install_mfront_header(MFront MaterialPropertyInterfaceFactory.hxx)
install_mfront_header(MFront MaterialPropertyInterfaceProxy.hxx)
install_mfront_header(MFront MaterialPropertyInterfaceProxy.ixx)
install_mfront_header(MFront MaterialPropertyParametersHandler.hxx)
install_mfront_header(MFront CastemMaterialPropertyInterface.hxx)
install_mfront_header(MFront ModelDSLCommon.hxx)
install_mfront_header(MFront ModelDSLBase.hxx)
install_mfront_header(MFront ModelDSLBase.ixx)
install_mfront_header(MFront ModelDescription.hxx)
install_mfront_header(MFront MaterialPropertyDescription.hxx)
install_mfront_header(MFront BehaviourData.hxx)
install_mfront_header(MFront BehaviourDescription.hxx)
install_mfront_header(MFront BehaviourDescription.ixx)
install_mfront_header(MFront BehaviourSymmetryType.hxx)
install_mfront_header(MFront Gradient.hxx)
install_mfront_header(MFront ThermodynamicForce.hxx)
install_mfront_header(MFront DSLBase.hxx)
install_mfront_header(MFront DSLBase.ixx)
install_mfront_header(MFront InterfaceBase.hxx)
install_mfront_header(MFront DSLUtilities.hxx)
install_mfront_header(MFront DSLUtilities.ixx)
install_mfront_header(MFront BehaviourDSLUtilities.hxx)
install_mfront_header(MFront CodeGeneratorUtilities.hxx)
install_mfront_header(MFront CodeGeneratorUtilities.ixx)
install_mfront_header(MFront SupportedTypes.hxx)
install_mfront_header(MFront VarHandler.hxx)
install_mfront_header(MFront StaticVarHandler.hxx)
install_mfront_header(MFront VariableAttribute.hxx)
install_mfront_header(MFront VariableBoundsDescription.hxx)
install_mfront_header(MFront VariableDescriptionBase.hxx)
install_mfront_header(MFront VariableDescription.hxx)
install_mfront_header(MFront VariableDescription.ixx)
install_mfront_header(MFront BehaviourVariableDescription.hxx)
install_mfront_header(MFront StaticVariableDescription.hxx)
install_mfront_header(MFront LawFunction.hxx)
install_mfront_header(MFront DefaultDSLBase.hxx)
install_mfront_header(MFront DefaultDSL.hxx)
install_mfront_header(MFront DefaultCZMDSL.hxx)
install_mfront_header(MFront DefaultFiniteStrainDSL.hxx)
install_mfront_header(MFront MaterialPropertyDSL.hxx)
install_mfront_header(MFront ModelDSL.hxx)
install_mfront_header(MFront BehaviourMaterialProperty.hxx)
install_mfront_header(MFront SymbolsGenerator.hxx)
install_mfront_header(MFront UMATInterfaceBase.hxx)
install_mfront_header(MFront GenericMaterialPropertyInterfaceBase.hxx)
install_mfront_header(MFront GenericMaterialPropertyInterface.hxx)
install_mfront_header(MFront GenericBehaviourInterface.hxx)
install_mfront_header(MFront GenericBehaviourSymbolsGenerator.hxx)
install_mfront_header(MFront GenericModelInterface.hxx)
install_mfront_header(MFront CastemModelInterface.hxx)
install_mfront_header(MFront MTestFileGeneratorBase.hxx)
install_mfront_header(MFront UmatSmallStrainMTestFileGenerator.hxx)
install_mfront_header(MFront UmatFiniteStrainMTestFileGenerator.hxx)
install_mfront_header(MFront GenericBehaviourMTestFileGenerator.hxx)
install_mfront_header(MFront GenericBehaviourSmallStrainMTestFileGenerator.hxx)
install_mfront_header(MFront GenericBehaviourFiniteStrainMTestFileGenerator.hxx)
install_mfront_header(MFront BehaviourBrickDescription.hxx)
install_mfront_header(MFront AbstractBehaviourBrick.hxx)
install_mfront_header(MFront BehaviourBrickBase.hxx)
install_mfront_header(MFront BehaviourBrickFactory.hxx)
install_mfront_header(MFront BehaviourProfiler.hxx)
install_mfront_header(MFront LocalDataStructure.hxx)
install_mfront_header(MFront AbstractBehaviourCodeGenerator.hxx)
install_mfront_header(MFront BehaviourCodeGeneratorBase.hxx)
install_mfront_header(MFront DefaultCodeGeneratorBase.hxx)
install_mfront_header(MFront DefaultCZMCodeGenerator.hxx)
install_mfront_header(MFront DefaultFiniteStrainCodeGenerator.hxx)
install_mfront_header(MFront RungeKuttaCodeGeneratorBase.hxx)
install_mfront_header(MFront ImplicitCodeGeneratorBase.hxx)
install_mfront_header(MFront IsotropicBehaviourCodeGeneratorBase.hxx)
install_mfront_header(MFront IsotropicStrainHardeningMisesCreepCodeGenerator.hxx)
install_mfront_header(MFront IsotropicMisesPlasticFlowCodeGenerator.hxx)
install_mfront_header(MFront IsotropicMisesCreepCodeGenerator.hxx)
install_mfront_header(MFront MultipleIsotropicMisesFlowsCodeGenerator.hxx)
install_mfront_header(MFront MFrontTemplateGenerationOptions.hxx)
install_mfront_header(MFront/BehaviourBrick OptionDescription.hxx)
install_mfront_header(MFront/BehaviourBrick BrickUtilities.hxx)
install_mfront_header(MFront/BehaviourBrick BrickUtilities.ixx)
install_mfront_header(MFront/BehaviourBrick PorosityEvolutionAlgorithm.hxx)
install_mfront_header(MFront/BehaviourBrick StressPotential.hxx)
install_mfront_header(MFront/BehaviourBrick HookeStressPotentialBase.hxx)
install_mfront_header(MFront/BehaviourBrick HookeStressPotential.hxx)
install_mfront_header(MFront/BehaviourBrick DDIF2StressPotential.hxx)
install_mfront_header(MFront/BehaviourBrick ScalarDamageHookeStressPotentialBase.hxx)
install_mfront_header(MFront/BehaviourBrick ScalarDamageHookeStressPotential.hxx)
install_mfront_header(MFront/BehaviourBrick StressPotentialFactory.hxx)
install_mfront_header(MFront/BehaviourBrick InelasticFlowFactory.hxx)
install_mfront_header(MFront/BehaviourBrick InelasticFlow.hxx)
install_mfront_header(MFront/BehaviourBrick InelasticFlowBase.hxx)
install_mfront_header(MFront/BehaviourBrick PorosityNucleationModelFactory.hxx)
install_mfront_header(MFront/BehaviourBrick PorosityNucleationModel.hxx)
install_mfront_header(MFront/BehaviourBrick PorosityNucleationModelBase.hxx)
install_mfront_header(MFront/BehaviourBrick StrainBasedPorosityNucleationModelBase.hxx)
install_mfront_header(MFront/BehaviourBrick StressBasedPorosityNucleationModelBase.hxx)
install_mfront_header(MFront/BehaviourBrick PowerLawStrainBasedPorosityNucleationModel.hxx)
install_mfront_header(MFront/BehaviourBrick PowerLawStressBasedPorosityNucleationModel.hxx)
install_mfront_header(MFront/BehaviourBrick ChuNeedleman1980StrainBasedPorosityNucleationModel.hxx)
install_mfront_header(MFront/BehaviourBrick ChuNeedleman1980StressBasedPorosityNucleationModel.hxx)
install_mfront_header(MFront/BehaviourBrick NortonHoffViscoplasticFlow.hxx)
install_mfront_header(MFront/BehaviourBrick UserDefinedViscoplasticFlow.hxx)
install_mfront_header(MFront/BehaviourBrick HyperbolicSineViscoplasticFlow.hxx)
install_mfront_header(MFront/BehaviourBrick ViscoplasticFlowBase.hxx)
install_mfront_header(MFront/BehaviourBrick PlasticInelasticFlow.hxx)
install_mfront_header(MFront/BehaviourBrick HarmonicSumOfNortonHoffViscoplasticFlows.hxx)
install_mfront_header(MFront/BehaviourBrick StressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick StressCriterionBase.hxx)
install_mfront_header(MFront/BehaviourBrick StandardStressCriterionBase.hxx)
install_mfront_header(MFront/BehaviourBrick StandardPorousStressCriterionBase.hxx)
install_mfront_header(MFront/BehaviourBrick MisesStressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick Hill1948StressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick Barlat2004StressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick Hosford1972StressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick Drucker1949StressCriterion.hxx)			
install_mfront_header(MFront/BehaviourBrick Cazacu2001StressCriterion.hxx)			
install_mfront_header(MFront/BehaviourBrick Cazacu2004IsotropicStressCriterion.hxx)			
install_mfront_header(MFront/BehaviourBrick Cazacu2004OrthotropicStressCriterion.hxx)			
install_mfront_header(MFront/BehaviourBrick MohrCoulombStressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick MichelAndSuquet1992HollowSphereStressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick GursonTvergaardNeedleman1982StressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick RousselierTanguyBesson2002StressCriterion.hxx)
install_mfront_header(MFront/BehaviourBrick StressCriterionFactory.hxx)
install_mfront_header(MFront/BehaviourBrick IsotropicHardeningRule.hxx)
install_mfront_header(MFront/BehaviourBrick LinearIsotropicHardeningRule.hxx)
install_mfront_header(MFront/BehaviourBrick SwiftIsotropicHardeningRule.hxx)
install_mfront_header(MFront/BehaviourBrick PowerIsotropicHardeningRule.hxx)
install_mfront_header(MFront/BehaviourBrick VoceIsotropicHardeningRule.hxx)
install_mfront_header(MFront/BehaviourBrick DataIsotropicHardeningRule.hxx)
install_mfront_header(MFront/BehaviourBrick UserDefinedIsotropicHardeningRule.hxx)

=== mfront/src/CMakeLists.txt ===
configure_file(${PROJECT_SOURCE_DIR}/mfront/src/MFrontHeader.cxx.in
               ${PROJECT_BINARY_DIR}/mfront/src/MFrontHeader.cxx)

# MFrontLogStream
mfront_library(MFrontLogStream
  MFrontLogStream.cxx)
target_include_directories(MFrontLogStream
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
if(enable-static)
  target_include_directories(MFrontLogStream-static
    PUBLIC 
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)
endif(enable-static)

# MFrontLogProfiling
mfront_library(MFrontProfiling
  BehaviourProfiler.cxx)
target_include_directories(MFrontProfiling
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
if(UNIX AND (NOT APPLE) AND (NOT HAIKU) AND (NOT (CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")))
   target_link_libraries(MFrontProfiling PRIVATE rt)
endif(UNIX AND (NOT APPLE) AND (NOT HAIKU) AND (NOT (CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")))
if(enable-static)
  target_include_directories(MFrontProfiling-static
    PUBLIC 
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)
  if(UNIX AND (NOT APPLE) AND (NOT HAIKU) AND (NOT (CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")))
    target_link_libraries(MFrontProfiling-static PRIVATE rt)
  endif(UNIX AND (NOT APPLE) AND (NOT HAIKU) AND (NOT (CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")))
endif(enable-static)
# MTestFileGenerator
mfront_library(MTestFileGenerator
  MTestFileGeneratorBase.cxx
  UmatSmallStrainMTestFileGenerator.cxx
  UmatFiniteStrainMTestFileGenerator.cxx
  GenericBehaviourMTestFileGenerator.cxx
  GenericBehaviourSmallStrainMTestFileGenerator.cxx
  GenericBehaviourFiniteStrainMTestFileGenerator.cxx)
target_include_directories(MTestFileGenerator
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
   $<INSTALL_INTERFACE:include>)
target_link_libraries(MTestFileGenerator
  PUBLIC tfel::TFELMaterial
  PUBLIC tfel::TFELMath
  PUBLIC tfel::TFELUtilities
  PUBLIC tfel::TFELException)
if(enable-static)
    target_include_directories(MTestFileGenerator-static
    PUBLIC 
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
    $<INSTALL_INTERFACE:include>)
  target_link_libraries(MTestFileGenerator-static
    PUBLIC tfel::TFELMaterial
    PUBLIC tfel::TFELMath
    PUBLIC tfel::TFELUtilities
    PUBLIC tfel::TFELException)
endif(enable-static)

# TFELMFront

set(TFELMFront_SOURCES
    MFront.cxx
    MFrontBase.cxx
    GlobalDomainSpecificLanguageOptionsManager.cxx
    MaterialKnowledgeDescription.cxx
    PathSpecifier.cxx
    MFrontUtilities.cxx
    GeneratorOptions.cxx
    CMakeGenerator.cxx
    MakefileGenerator.cxx
    CodeBlock.cxx
    FileDescription.cxx
    TargetsDescription.cxx
    OverridableImplementation.cxx
    CompiledTargetDescriptionBase.cxx
    LibraryDescription.cxx
    ExecutableDescription.cxx
    SpecificTargetDescription.cxx
    MFrontWarningMode.cxx
    MFrontDebugMode.cxx
    PedanticMode.cxx
    MFrontLock.cxx
    InstallPath.cxx
    SearchPathsHandler.cxx
    InitInterfaces.cxx
    InitDSLs.cxx
    DSLFactory.cxx
    DataInterpolationUtilities.cxx
    Gradient.cxx
    ThermodynamicForce.cxx
    LawFunction.cxx
    MaterialPropertyDescription.cxx
    MaterialPropertyParametersHandler.cxx
    BehaviourData.cxx
    BehaviourDescription.cxx
    VariableDescriptionBase.cxx
    VariableDescription.cxx
    BehaviourVariableDescription.cxx
    StaticVariableDescription.cxx
    VariableBoundsDescription.cxx
    BehaviourDSLCommon.cxx
    ModelDescription.cxx
    ModelDSLCommon.cxx
    ModelDSL.cxx
    BehaviourDSLDescription.cxx
    AbstractDSL.cxx
    AbstractBehaviourDSL.cxx
    AbstractBehaviourInterface.cxx
    AbstractMaterialPropertyInterface.cxx
    AbstractModelInterface.cxx
    SupportedTypes.cxx
    DSLBase.cxx
    InterfaceBase.cxx
    DSLUtilities.cxx
    BehaviourDSLUtilities.cxx
    CodeGeneratorUtilities.cxx
    FiniteStrainBehaviourTangentOperatorConversion.cxx
    FiniteStrainBehaviourTangentOperatorConversionPath.cxx
    MaterialPropertyInterfaceFactory.cxx
    BehaviourInterfaceFactory.cxx
    ModelInterfaceFactory.cxx
    DefaultDSLBase.cxx
    DefaultDSL.cxx
    DefaultCZMDSL.cxx
    DefaultFiniteStrainDSL.cxx
    DefaultGenericBehaviourDSL.cxx
    DefaultModelDSL.cxx
    MaterialPropertyDSL.cxx
    IsotropicMisesCreepDSL.cxx
    IsotropicStrainHardeningMisesCreepDSL.cxx
    IsotropicMisesPlasticFlowDSL.cxx
    RungeKuttaDSLBase.cxx
    RungeKuttaDSL.cxx
    RungeKuttaFiniteStrainDSL.cxx
    RungeKuttaGenericBehaviourDSL.cxx
    RungeKuttaModelDSL.cxx
    ImplicitDSLBase.cxx
    ImplicitDSL.cxx
    ImplicitDSLII.cxx
    ImplicitFiniteStrainDSL.cxx
    ImplicitGenericBehaviourDSL.cxx
    ImplicitModelDSL.cxx
    ImplicitCZMDSL.cxx
    NonLinearSystemSolver.cxx
    NonLinearSystemSolverBase.cxx
    NonLinearSystemSolverFactory.cxx
    UserDefinedNonLinearSystemSolver.cxx
    PowellDogLegAlgorithmBase.cxx
    NewtonRaphsonSolvers.cxx
    BroydenSolvers.cxx
    SecondBroydenSolver.cxx
    LevenbergMarquardtSolvers.cxx
    BehaviourBrickDescription.cxx
    AbstractBehaviourBrick.cxx
    BehaviourBrickFactory.cxx
    BehaviourBrickBase.cxx
    StandardElasticityBrick.cxx
    StandardElastoViscoPlasticityBrick.cxx
    DDIF2Brick.cxx
    FiniteStrainSingleCrystalBrick.cxx
    LocalDataStructure.cxx
    PerformanceProfiling.cxx
    MultipleIsotropicMisesFlowsDSL.cxx
    IsotropicBehaviourDSLBase.cxx
    AbstractBehaviourCodeGenerator.cxx
    BehaviourCodeGeneratorBase.cxx
    DefaultCodeGeneratorBase.cxx
    DefaultCZMCodeGenerator.cxx
    DefaultFiniteStrainCodeGenerator.cxx
    RungeKuttaCodeGeneratorBase.cxx
    ImplicitCodeGeneratorBase.cxx
    IsotropicBehaviourCodeGeneratorBase.cxx
    IsotropicStrainHardeningMisesCreepCodeGenerator.cxx
    IsotropicMisesPlasticFlowCodeGenerator.cxx
    IsotropicMisesCreepCodeGenerator.cxx
    MultipleIsotropicMisesFlowsCodeGenerator.cxx
    MFrontMaterialPropertyInterface.cxx
    MFrontBehaviourInterface.cxx
    CMaterialPropertyInterfaceBase.cxx
    CMaterialPropertyInterface.cxx
    CppMaterialPropertyInterface.cxx
    CppTestMaterialPropertyInterface.cxx
    ExcelMaterialPropertyInterface.cxx
    OctaveMaterialPropertyInterface.cxx
    ExcelMaterialPropertyInternalInterface.cxx
    MFrontModelInterface.cxx
    BehaviourMaterialProperty.cxx
    BehaviourInterfaceBase.cxx
    SymbolsGenerator.cxx
    UMATInterfaceBase.cxx
    GenericMaterialPropertyInterfaceBase.cxx
    GenericMaterialPropertyInterface.cxx
    GenericBehaviourInterface.cxx
    GenericBehaviourSymbolsGenerator.cxx
    GenericModelInterface.cxx
    OptionDescription.cxx
    BrickUtilities.cxx
    StressPotential.cxx
    HookeStressPotentialBase.cxx
    HookeStressPotential.cxx
    ScalarDamageHookeStressPotentialBase.cxx
    ScalarDamageHookeStressPotential.cxx
    DDIF2StressPotential.cxx
    StressPotentialFactory.cxx
    InelasticFlow.cxx
    InelasticFlowFactory.cxx
    InelasticFlowBase.cxx
    ViscoplasticFlowBase.cxx
    NortonHoffViscoplasticFlow.cxx
    HyperbolicSineViscoplasticFlow.cxx
    HarmonicSumOfNortonHoffViscoplasticFlows.cxx
    UserDefinedViscoplasticFlow.cxx
    PlasticInelasticFlow.cxx
    PorosityNucleationModel.cxx
    PorosityNucleationModelFactory.cxx
    PorosityNucleationModelBase.cxx
    StrainBasedPorosityNucleationModelBase.cxx
    StressBasedPorosityNucleationModelBase.cxx
    ChuNeedleman1980StrainBasedPorosityNucleationModel.cxx
    ChuNeedleman1980StressBasedPorosityNucleationModel.cxx
    PowerLawStrainBasedPorosityNucleationModel.cxx
    PowerLawStressBasedPorosityNucleationModel.cxx
    StressCriterion.cxx
    StressCriterionBase.cxx
    StandardStressCriterionBase.cxx
    StandardPorousStressCriterionBase.cxx
    MisesStressCriterion.cxx
    Hill1948StressCriterion.cxx
    Barlat2004StressCriterion.cxx
    Hosford1972StressCriterion.cxx
    Drucker1949StressCriterion.cxx
    Cazacu2001StressCriterion.cxx
    Cazacu2004IsotropicStressCriterion.cxx
    Cazacu2004OrthotropicStressCriterion.cxx
    MohrCoulombStressCriterion.cxx
    MichelAndSuquet1992HollowSphereStressCriterion.cxx
    GursonTvergaardNeedleman1982StressCriterion.cxx
    RousselierTanguyBesson2002StressCriterion.cxx
    StressCriterionFactory.cxx
    IsotropicHardeningRule.cxx
    LinearIsotropicHardeningRule.cxx
    PowerIsotropicHardeningRule.cxx
    SwiftIsotropicHardeningRule.cxx
    VoceIsotropicHardeningRule.cxx
    DataIsotropicHardeningRule.cxx
    StrainRateSensitiveIsotropicHardeningRule.cxx
    UserDefinedIsotropicHardeningRule.cxx
    IsotropicHardeningRuleFactory.cxx
    StrainRateSensitivityFactor.cxx
    StrainRateSensitivityFactorFactory.cxx
    CowperSymondsStrainRateSensitivityFactor.cxx
    JohnsonCookStrainRateSensitivityFactor.cxx
    KinematicHardeningRule.cxx
    KinematicHardeningRuleBase.cxx
    PragerKinematicHardeningRule.cxx
    Chaboche2012KinematicHardeningRule.cxx
    BurletCailletaudKinematicHardeningRule.cxx
    ArmstrongFrederickKinematicHardeningRule.cxx
    DelobelleRobinetSchafflerKinematicHardeningRule.cxx
    KinematicHardeningRuleFactory.cxx
    ${PROJECT_BINARY_DIR}/mfront/src/MFrontHeader.cxx)

if(HAVE_GNUPLOT)
    set(TFELMFront_SOURCES
	GnuplotMaterialPropertyInterface.cxx
	${TFELMFront_SOURCES})
endif(HAVE_GNUPLOT)

if(HAVE_PYTHON)
    set(TFELMFront_SOURCES
	PythonMaterialPropertyInterface.cxx
	${TFELMFront_SOURCES})
endif(HAVE_PYTHON)

if(HAVE_JAVA)
    set(TFELMFront_SOURCES
	JavaMaterialPropertyInterface.cxx
	${TFELMFront_SOURCES})
endif(HAVE_JAVA)

if(HAVE_FORTRAN)
    set(TFELMFront_SOURCES
      FortranMaterialPropertyInterface.cxx
      Fortran03MaterialPropertyInterface.cxx
      ${TFELMFront_SOURCES})
endif(HAVE_FORTRAN)

if(HAVE_CASTEM)
    set(TFELMFront_SOURCES
	CastemInterface.cxx
	Castem21Interface.cxx
	CastemSymbolsGenerator.cxx
	CastemMaterialPropertyInterface.cxx
	CastemModelInterface.cxx
	AmitexInterface.cxx
	${TFELMFront_SOURCES})
    set(CastemInterface_SOURCES
	CastemInterfaceExceptions.cxx
	CastemFiniteStrain.cxx
	CastemComputeStiffnessTensor.cxx
	CastemComputeThermalExpansionCoefficientTensor.cxx
	CastemRotationMatrix.cxx
	CastemTangentOperator.cxx
	CastemOutOfBoundsPolicy.cxx
	CastemGetModellingHypothesis.cxx
	CastemStressFreeExpansionHandler.cxx
	CastemException.cxx)
    mfront_library(CastemInterface ${CastemInterface_SOURCES})
    target_link_libraries(CastemInterface
      MTestFileGenerator
      TFELUtilities
      TFELException)
endif(HAVE_CASTEM)

if(HAVE_ASTER)
  set(TFELMFront_SOURCES
    AsterInterface.cxx
    AsterSymbolsGenerator.cxx
    ${TFELMFront_SOURCES})
  set(AsterInterface_SOURCES
    AsterInterfaceExceptions.cxx
    AsterException.cxx
    AsterRotationMatrix.cxx
    AsterFiniteStrainRotationMatrix.cxx
    AsterComputeStiffnessTensor.cxx
    AsterStressFreeExpansionHandler.cxx
    AsterComputeThermalExpansionCoefficientTensor.cxx
    AsterTangentOperator.cxx)
  mfront_library(AsterInterface ${AsterInterface_SOURCES})
  target_link_libraries(AsterInterface
    MTestFileGenerator
    TFELUtilities
    TFELException)
endif(HAVE_ASTER)

if(HAVE_ABAQUS)
  set(TFELMFront_SOURCES
    AbaqusInterfaceBase.cxx
    AbaqusInterface.cxx
    AbaqusExplicitInterface.cxx
    AbaqusSymbolsGenerator.cxx
    AbaqusExplicitSymbolsGenerator.cxx
    ${TFELMFront_SOURCES})
  set(AbaqusInterface_SOURCES
    AbaqusInterfaceExceptions.cxx
    AbaqusException.cxx
    AbaqusComputeStiffnessTensor.cxx
    AbaqusStressFreeExpansionHandler.cxx
    AbaqusComputeThermalExpansionCoefficientTensor.cxx
    AbaqusFiniteStrain.cxx)
  mfront_library(AbaqusInterface ${AbaqusInterface_SOURCES})

=== mfront/tests/CMakeLists.txt ===
add_subdirectory(properties)
add_subdirectory(behaviours)
add_subdirectory(models)
add_subdirectory(unit-tests)

=== mtest/include/CMakeLists.txt ===
install_mtest_header(MTest Config.hxx)
install_mtest_header(MTest Types.hxx)
install_mtest_header(MTest MTestFileExport.hxx)
install_mtest_header(MTest MaterialProperty.hxx)
install_mtest_header(MTest MaterialPropertyBase.hxx)
install_mtest_header(MTest GenericMaterialProperty.hxx)
install_mtest_header(MTest CastemMaterialProperty.hxx)
install_mtest_header(MTest CyranoMaterialProperty.hxx)
install_mtest_header(MTest RoundingMode.hxx)
install_mtest_header(MTest Solver.hxx)
install_mtest_header(MTest SolverOptions.hxx)
install_mtest_header(MTest SolverWorkSpace.hxx)
install_mtest_header(MTest GenericSolver.hxx)
install_mtest_header(MTest Study.hxx)
install_mtest_header(MTest StudyParameter.hxx)
install_mtest_header(MTest StudyCurrentState.hxx)
install_mtest_header(MTest StudyCurrentState.ixx)
install_mtest_header(MTest StructureCurrentState.hxx)
install_mtest_header(MTest CurrentState.hxx)
install_mtest_header(MTest Scheme.hxx)
install_mtest_header(MTest SchemeBase.hxx)
install_mtest_header(MTest SingleStructureScheme.hxx)
install_mtest_header(MTest MTest.hxx)
install_mtest_header(MTest PipeTest.hxx)
install_mtest_header(MTest PipeTest.hxx)
install_mtest_header(MTest PipeMesh.hxx)
install_mtest_header(MTest PipeFailureCriterion.hxx)
install_mtest_header(MTest PipeFailureCriteriaFactory.hxx)
install_mtest_header(MTest PipeProfileHandler.hxx)
install_mtest_header(MTest UserDefinedPostProcessing.hxx)
install_mtest_header(MTest Behaviour.hxx)
install_mtest_header(MTest BehaviourWrapperBase.hxx)
install_mtest_header(MTest BehaviourWorkSpace.hxx)
install_mtest_header(MTest StandardBehaviourBase.hxx)
install_mtest_header(MTest UmatNormaliseTangentOperator.hxx)
install_mtest_header(MTest GenericBehaviour.hxx)
install_mtest_header(MTest CastemInterfaceVersion.hxx)
install_mtest_header(MTest CastemStandardBehaviour.hxx)
install_mtest_header(MTest CastemSmallStrainBehaviour.hxx)
install_mtest_header(MTest CastemFiniteStrainBehaviour.hxx)
install_mtest_header(MTest CastemFiniteStrainBehaviour2.hxx)
install_mtest_header(MTest CastemCohesiveZoneModel.hxx)
install_mtest_header(MTest CastemModel.hxx)
install_mtest_header(MTest CastemUmatStandardBehaviour.hxx)
install_mtest_header(MTest CastemUmatSmallStrainBehaviour.hxx)
install_mtest_header(MTest CastemUmatFiniteStrainBehaviour.hxx)
install_mtest_header(MTest MistralBehaviour.hxx)
install_mtest_header(MTest AsterStandardBehaviour.hxx)
install_mtest_header(MTest AsterSmallStrainBehaviour.hxx)
install_mtest_header(MTest AsterFiniteStrainBehaviour.hxx)
install_mtest_header(MTest AsterCohesiveZoneModel.hxx)
install_mtest_header(MTest AsterLogarithmicStrainBehaviourWrapper.hxx)
install_mtest_header(MTest AbaqusStandardBehaviour.hxx)
install_mtest_header(MTest AbaqusSmallStrainBehaviour.hxx)
install_mtest_header(MTest AbaqusFiniteStrainBehaviour.hxx)
install_mtest_header(MTest AbaqusExplicitBehaviour.hxx)
install_mtest_header(MTest CalculiXStandardBehaviour.hxx)
install_mtest_header(MTest CalculiXSmallStrainBehaviour.hxx)
install_mtest_header(MTest CalculiXFiniteStrainBehaviour.hxx)
install_mtest_header(MTest AnsysStandardBehaviour.hxx)
install_mtest_header(MTest AnsysSmallStrainBehaviour.hxx)
install_mtest_header(MTest AnsysFiniteStrainBehaviour.hxx)
install_mtest_header(MTest AnsysNormaliseTangentOperator.hxx)
install_mtest_header(MTest CyranoBehaviour.hxx)
install_mtest_header(MTest Evolution.hxx)
install_mtest_header(MTest GenericEvolution.hxx)
install_mtest_header(MTest CastemEvolution.hxx)
install_mtest_header(MTest CyranoEvolution.hxx)
install_mtest_header(MTest FunctionEvolution.hxx)
install_mtest_header(MTest OxidationStatusEvolution.hxx)
install_mtest_header(MTest Constraint.hxx)
install_mtest_header(MTest ConstraintBase.hxx)
install_mtest_header(MTest NonLinearConstraint.hxx)
install_mtest_header(MTest ImposedGradient.hxx)
install_mtest_header(MTest ImposedThermodynamicForce.hxx)
install_mtest_header(MTest AccelerationAlgorithmFactory.hxx)
install_mtest_header(MTest AccelerationAlgorithm.hxx)
install_mtest_header(MTest SecantAccelerationAlgorithm.hxx)
install_mtest_header(MTest CastemAccelerationAlgorithm.hxx)
install_mtest_header(MTest IronsTuckAccelerationAlgorithm.hxx)
install_mtest_header(MTest SteffensenAccelerationAlgorithm.hxx)
install_mtest_header(MTest UAndersonAccelerationAlgorithm.hxx)
install_mtest_header(MTest FAndersonAccelerationAlgorithm.hxx)
install_mtest_header(MTest SchemeParserBase.hxx)
install_mtest_header(MTest SingleStructureSchemeParser.hxx)
install_mtest_header(MTest TextDataUtilities.hxx)
install_mtest_header(MTest MTestParser.hxx)
install_mtest_header(MTest PipeTestParser.hxx)
install_mtest_header(MTest GasEquationOfState.hxx)
install_mtest_header(MTest DianaFEASmallStrainBehaviour.hxx)

=== mtest/src/CMakeLists.txt ===
set(TFELMTest_SOURCES
  MTestFileExport.cxx
  MaterialProperty.cxx
  MaterialPropertyBase.cxx
  GenericMaterialProperty.cxx
  CastemMaterialProperty.cxx
  CyranoMaterialProperty.cxx
  RoundingMode.cxx
  Study.cxx
  StudyCurrentState.cxx
  StructureCurrentState.cxx
  CurrentState.cxx
  Solver.cxx
  SolverOptions.cxx
  GenericSolver.cxx
  Scheme.cxx
  SchemeBase.cxx
  SingleStructureScheme.cxx
  AnalyticalTest.cxx
  ReferenceFileComparisonTest.cxx
  Evolution.cxx
  GenericEvolution.cxx
  CastemEvolution.cxx
  CyranoEvolution.cxx
  FunctionEvolution.cxx
  OxidationStatusEvolution.cxx
  Behaviour.cxx
  BehaviourWrapperBase.cxx
  SmallStrainTridimensionalBehaviourWrapper.cxx
  LogarithmicStrain1DBehaviourWrapper.cxx
  BehaviourWorkSpace.cxx
  StandardBehaviourBase.cxx
  GenericBehaviour.cxx
  UmatNormaliseTangentOperator.cxx
  Constraint.cxx
  ConstraintBase.cxx
  NonLinearConstraint.cxx
  ImposedGradient.cxx
  ImposedThermodynamicForce.cxx
  AccelerationAlgorithmFactory.cxx
  AccelerationAlgorithm.cxx
  CastemAccelerationAlgorithm.cxx
  AlternateSecantAccelerationAlgorithm.cxx
  AlternateDelta2AccelerationAlgorithm.cxx
  Alternate2DeltaAccelerationAlgorithm.cxx
  CrossedSecantAccelerationAlgorithm.cxx
  CrossedDelta2AccelerationAlgorithm.cxx
  Crossed2DeltaAccelerationAlgorithm.cxx
  Crossed2DeltabisAccelerationAlgorithm.cxx
  SecantAccelerationAlgorithm.cxx
  SteffensenAccelerationAlgorithm.cxx
  IronsTuckAccelerationAlgorithm.cxx
  UAndersonAccelerationAlgorithm.cxx
  FAndersonAccelerationAlgorithm.cxx
  UserDefinedPostProcessing.cxx
  MTest.cxx
  PipeTest.cxx
  PipeLinearElement.cxx
  PipeQuadraticElement.cxx
  PipeCubicElement.cxx
  PipeProfile.cxx
  PipeProfileHandler.cxx
  PipeFailureCriterion.cxx
  PipeFailureCriteriaFactory.cxx
  TextDataUtilities.cxx
  SchemeParserBase.cxx
  SingleStructureSchemeParser.cxx
  MTestParser.cxx
  PipeTestParser.cxx
  GasEquationOfState.cxx)

set(TFELMTest_LDADD
  MFrontLogStream
  TFELMaterial
  TFELMathParser
  TFELMath
  TFELSystem
  TFELUtilities
  TFELException
  TFELTests
  TFELConfig)

if(HAVE_CASTEM)
  set(TFELMTest_SOURCES
    CastemStandardBehaviour.cxx
    CastemSmallStrainBehaviour.cxx
    CastemFiniteStrainBehaviour.cxx
    CastemFiniteStrainBehaviour2.cxx
    CastemCohesiveZoneModel.cxx
    CastemModel.cxx
    CastemUmatStandardBehaviour.cxx
    CastemUmatSmallStrainBehaviour.cxx
    CastemUmatFiniteStrainBehaviour.cxx
    MistralBehaviour.cxx
    ${TFELMTest_SOURCES})
  set(TFELMTest_LDADD
    CastemInterface
    ${TFELMTest_LDADD})
endif(HAVE_CASTEM)

if(HAVE_ASTER)
set(TFELMTest_SOURCES
    AsterStandardBehaviour.cxx
    AsterSmallStrainBehaviour.cxx
    AsterFiniteStrainBehaviour.cxx
    AsterCohesiveZoneModel.cxx
    AsterLogarithmicStrainBehaviourWrapper.cxx
    ${TFELMTest_SOURCES})
set(TFELMTest_LDADD
    AsterInterface
    ${TFELMTest_LDADD})
endif(HAVE_ASTER)

if(HAVE_ABAQUS)
set(TFELMTest_SOURCES
    AbaqusStandardBehaviour.cxx
    AbaqusSmallStrainBehaviour.cxx
    AbaqusFiniteStrainBehaviour.cxx
    AbaqusExplicitBehaviour.cxx
    ${TFELMTest_SOURCES})
set(TFELMTest_LDADD
    AbaqusInterface
    ${TFELMTest_LDADD})
endif(HAVE_ABAQUS)

if(HAVE_CALCULIX)
set(TFELMTest_SOURCES
    CalculiXStandardBehaviour.cxx
    CalculiXSmallStrainBehaviour.cxx
    CalculiXFiniteStrainBehaviour.cxx
    ${TFELMTest_SOURCES})
endif(HAVE_CALCULIX)

if(HAVE_ANSYS)
set(TFELMTest_SOURCES
    AnsysStandardBehaviour.cxx
    AnsysSmallStrainBehaviour.cxx
    AnsysFiniteStrainBehaviour.cxx
    AnsysNormaliseTangentOperator.cxx
    ${TFELMTest_SOURCES})
set(TFELMTest_LDADD
    AnsysInterface
    ${TFELMTest_LDADD})
endif(HAVE_ANSYS)

if(HAVE_CYRANO)
set(TFELMTest_SOURCES
    CyranoBehaviour.cxx
    ${TFELMTest_SOURCES})
set(TFELMTest_LDADD
    CyranoInterface
    ${TFELMTest_LDADD})
endif(HAVE_CYRANO)

if(HAVE_DIANAFEA)
  set(TFELMTest_SOURCES
    DianaFEASmallStrainBehaviour.cxx
    ${TFELMTest_SOURCES})
set(TFELMTest_LDADD
  DianaFEAInterface
  ${TFELMTest_LDADD})
endif(HAVE_DIANAFEA)

mtest_library(TFELMTest ${TFELMTest_SOURCES})
target_include_directories(TFELMTest
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mtest/include>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
target_link_libraries(TFELMTest PUBLIC ${TFELMTest_LDADD})
if(TFEL_HAVE_MADNEX)
  target_compile_definitions(TFELMTest
    PUBLIC MTEST_HAVE_MADNEX)
  target_link_libraries(TFELMTest
    PRIVATE madnex::Madnex)
endif(TFEL_HAVE_MADNEX)
if(enable-static)
  target_include_directories(TFELMTest-static
    PUBLIC 
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mtest/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)
  target_link_libraries(TFELMTest-static
    PUBLIC
    tfel::MFrontLogStream-static
    tfel::TFELMaterial-static
    tfel::TFELMathParser-static
    tfel::TFELMath-static
    tfel::TFELSystem-static
    tfel::TFELTests-static
    tfel::TFELConfig-static)
  if(TFEL_HAVE_MADNEX)
    target_compile_definitions(TFELMTest-static
      PUBLIC MTEST_HAVE_MADNEX)
    target_link_libraries(TFELMTest-static
      PRIVATE madnex::Madnex)
  endif(TFEL_HAVE_MADNEX)
endif(enable-static)

add_executable(mtest MTestMain.cxx)
set_property(TARGET mtest PROPERTY POSITION_INDEPENDENT_CODE TRUE)
if(WIN32 AND enable-static)
  set(mtest_static_link_libraries
    TFELMTest-static
    MFrontLogStream-static    
    TFELMaterial-static
    TFELMathParser-static
    TFELMath-static
    TFELSystem-static
    TFELUtilities-static
    TFELException-static
    TFELTests-static)
  if(HAVE_CASTEM)
    list(APPEND mtest_static_link_libraries UMATInterface-static)
  endif(HAVE_CASTEM)
  if(HAVE_ASTER)
    list(APPEND mtest_static_link_libraries AsterInterface-static)
  endif(HAVE_ASTER)
  if(HAVE_ABAQUS)
    list(APPEND mtest_static_link_libraries AbaqusInterface-static)
  endif(HAVE_ABAQUS)
  if(HAVE_CYRANO)
    list(APPEND mtest_static_link_libraries CyranoInterface-static)
  endif(HAVE_CYRANO)
  target_link_libraries(mtest PUBLIC ${mtest_static_link_libraries})
  set_target_properties(mtest PROPERTIES COMPILE_FLAGS "-DTFEL_STATIC_BUILD")
  set_target_properties(mtest PROPERTIES LINK_FLAGS "-static-libgcc -static") 
  set_target_properties(mtest PROPERTIES LINK_SEARCH_END_STATIC ON) 
else(WIN32 AND enable-static)
  target_link_libraries(mtest PUBLIC TFELMTest TFELSystem TFELUtilities TFELTests)
endif(WIN32 AND enable-static)

if(TFEL_HAVE_MADNEX)
  target_compile_definitions(mtest PUBLIC MTEST_HAVE_MADNEX)
  target_link_libraries(mtest PRIVATE madnex::Madnex)
endif(TFEL_HAVE_MADNEX)

if(TFEL_APPEND_SUFFIX)
  set_target_properties(mtest
    PROPERTIES OUTPUT_NAME "mtest-${TFEL_SUFFIX}")
endif(TFEL_APPEND_SUFFIX)

install(TARGETS mtest DESTINATION bin
  COMPONENT mtest)

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=tfel
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.1.0
pkgrel=2
pkgdesc='MFront: a code generation tool dedicated to material knowledge (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://thelfer.github.io/tfel/web/index.html'
msys2_repository_url='https://github.com/thelfer/tfel'
license=('spdx:GPL-3.0-or-later OR CECILL-2.1')
provides=("${MINGW_PACKAGE_PREFIX}-mfront")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-gnuplot")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-fc")
source=(${msys2_repository_url}/archive/TFEL-${pkgver}/${_realname}-TFEL-${pkgver}.tar.gz)
sha256sums=('1afd98200de332e97e86d109ce0e1aaa8f18cc6c6c81daec3218809509cdfad7')
noextract=("${_realname}-TFEL-${pkgver}.tar.gz")

prepare() {
  tar -xf "${_realname}-TFEL-${pkgver}.tar.gz" || true
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -Denable-python=OFF \
      -Denable-python-bindings=OFF \
      -Denable-aster=ON \
      -Denable-abaqus=ON \
      -Denable-ansys=ON \
      -Denable-europlexus=ON \
      -Denable-zmat=ON \
      -Denable-cyrano=ON \
      -Denable-calculix=ON \
      -Denable-comsol=ON \
      -Denable-diana-fea=ON \
      -Denable-lsdyna=ON \
      -Denable-cxx-17=ON \
      -Denable-fortran=ON \
      -Denable-portable-build=ON \
      -Denable-reference-doc=OFF \
      "${extra_config[@]}" \
      -S ${_realname}-TFEL-${pkgver} \
      -B build-${MSYSTEM}

  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" cmake --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/${_realname}-TFEL-${pkgver}/LICENCE-GNU-GPL \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE-GNU-GPL
  install -Dm644 "${srcdir}"/${_realname}-TFEL-${pkgver}/LICENCE-CECILL-A-EN \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE-CECILL-A-EN
}

# vim: ts=2 sw=2 et:
